# -*- coding:utf-8 -*-

# @Time    : 2018/4/27 10:50 AM

# @Author  : Swing

import scrapy
from elabSpider.items import RentalHouseItem
import logging
from elabSpider.email_util import send_email
import traceback


class RentalHouseSpider(scrapy.Spider):
    name = 'lfsrentalHouse'
    allowed_domains = [
        'nb.zu.anjuke.com',
        'nb.anjuke.com'
    ]
    start_urls = [
        'https://nb.anjuke.com/community/props/rent/1003094'
        # 'https://nb.zu.anjuke.com/rent/F717483045'
    ]

    def parse(self, response):
        try:
            community_list = response.xpath('//ul[@class="m-house-list"]/li/a/@href').extract()

            if community_list:
                for community_url in community_list:
                    yield scrapy.Request(community_url, callback=self.parse_item)
        except Exception as err:
            send_email('lfsrentalHouse get detail url error', response._url + '\n' + traceback.format_exc())
            logging.error('get detail url error ! url: ' + response._url + " reason: " + '-'.join(err.args))

        try:
            next_page = response.xpath(r'//div[@class="m-page"]/div[@class="multi-page"]/a[@class="aNxt"]/@href.....').extract_first()
            if next_page:
                yield scrapy.Request(next_page, callback=self.parse)
        except Exception as err:
            send_email('lfsrentalHouse get next page error', response._url + '\n' + traceback.format_exc())
            logging.error('get next page url error ! url: ' + response._url + " reason: " + '-'.join(err.args))

    def parse_item(self, response):
        try:
            item = RentalHouseItem.handle_response(response)
            yield item
        except Exception as err:
            send_email('lfsrentalHouse parse response error', response._url + '\n' + traceback.format_exc())
            logging.error('parse response error ! url: ' + response._url + " reason: " + '-'.join(err.args))
