# -*- coding: utf-8 -*-
import scrapy
import logging
from elabSpider.items import LfsAveragePriceItem
import traceback
from elabSpider.email_util import send_email


class LfsSpider(scrapy.Spider):
    name = 'lfsSoldAverage'
    allowed_domains = ['nb.anjuke.com']
    start_urls = ['https://nb.anjuke.com/community/view/1003094']
    # start_urls = ['https://nb.anjuke.com/community/view/275965?from=Filter_1&hfilter=filterlist']

    def parse(self, response):
        try:
            item = LfsAveragePriceItem.handle_response(response)
            yield item
        except Exception as err:
            send_email('lfsSoldAverage parse response error', response._url + '\n' + traceback.format_exc())
            logging.error('parse response error ! url: ' + response._url + " reason: " + '-'.join(err.args))



